------------------------------------------------------------------------
--| Cats Package Body
--| YOUR NAME AND DATE
------------------------------------------------------------------------

PACKAGE BODY Cats IS

   ---------------------------------------------

   FUNCTION MakeCat (
         Age    : AgeType;
         Lives  : LivesType) RETURN CatType IS

      TempCat : CatType;
   BEGIN
      TempCat.Age := Age;
      TempCat.Lives := Lives;
      RETURN TempCat;
   END MakeCat;

   ---------------------------------------------

   PROCEDURE IncreaseAge (
         Cat     : IN OUT CatType;
         Years   : IN Positive) IS
   BEGIN
      Cat.Age := Cat.Age + Years;
   EXCEPTION
      WHEN Constraint_Error =>
         RAISE Age_Error;
   END IncreaseAge;

   ---------------------------------------------

   PROCEDURE DecreaseLives (
         Cat : IN OUT CatType) IS
   BEGIN
      Cat.Lives := Cat.Lives - 1;
   EXCEPTION
      WHEN Constraint_Error =>
         RAISE Lives_Error;
   END DecreaseLives;

   ---------------------------------------------

   FUNCTION Age (Cat : CatType) RETURN AgeType IS
   BEGIN
      RETURN Cat.Age;
   END Age;

   ---------------------------------------------

   FUNCTION Lives (Cat : CatType) RETURN LivesType IS
   BEGIN
      RETURN Cat.Lives;
   END Lives;

END Cats;