
------------------------------------------------------------------------
--| Cats Package
--| YOUR NAME AND DATE
------------------------------------------------------------------------


PACKAGE Cats IS

   TYPE    CatType IS PRIVATE;

   SUBTYPE AgeType   IS Integer RANGE 0..15;
   SUBTYPE LivesType IS Integer RANGE 1..9;

   Age_Error   : EXCEPTION;
   Lives_Error : EXCEPTION;

   --------------------------------------

   FUNCTION MakeCat (
      Age   : AgeType;
      Lives : LivesType) RETURN CatType;

   PROCEDURE IncreaseAge (
      Cat   : IN OUT CatType;
      Years : IN Positive);
      -- Throws age error

   PROCEDURE DecreaseLives (Cat : IN OUT CatType);
      -- Throws lives error

   FUNCTION Age (Cat : CatType) RETURN AgeType;

   FUNCTION Lives (Cat : CatType) RETURN LivesType;

   --------------------------------------

PRIVATE

   TYPE CatType IS RECORD
      Age   : AgeType;
      Lives : LivesType;
   END RECORD;

END Cats;