WITH Ada.Text_Io;            USE Ada.Text_Io;
WITH Cats;                   USE Cats;
WITH Cats.Io;                USE Cats.Io;
WITH Maximum_Array_Generic;
WITH In_Array_Generic;

PROCEDURE CompareCats IS

   -- Declare an array of cats
   TYPE CatArrayType IS ARRAY (Integer RANGE <>) OF CatType;
   Cats : CatArrayType(1..5);
   
   -- Declare a cat variable
   Cat  : CatType;

   -- Instantiate two instances of the Maximum_Array_Generic function.
   -- The ads and adb files for this function are described in the book.
   -- You will need to include these files in your working directory.
   -- You will need to add CompareAges and CompareLives functions to 
   -- the Cats package.
   FUNCTION MaxAge IS NEW Maximum_Array_Generic (
      ValueType => CatType,
      IndexType => Integer,
      ArrayType => CatArrayType,
      Compare => CompareAges);

   FUNCTION MaxLives IS NEW Maximum_Array_Generic (
      ValueType => CatType,
      IndexType => Integer,
      ArrayType => CatArrayType,
      Compare => CompareLives);
      
   -- Instantiate an instance of the In_Array_Generic function.
   -- This generic function determines if an element is present in an array.
   -- You will need to write ads and adb files for this function.
   -- Here is a little something to get you started.
   --      FUNCTION In_Array_Generic (
   --         List  : ArrayType; 
   --         Value : ValueType) RETURN Boolean; 
   FUNCTION InArray IS NEW In_Array_Generic (
      ValueType => CatType,
      IndexType => Integer,
      ArrayType => CatArrayType);

BEGIN
   
   -- Read data for 5 cats into the array of cats.
   -- This code requires that you implement a get procedure
   -- in the child io package for cats.
   FOR I IN 1..5 LOOP
      Get (Cats(I));
   END LOOP;

   -- Display the cats entered by the user.
   -- This code requires that you implement a put procedure
   -- in the child io package for cats.
   New_Line;
   Put_Line ("You entered ");
   FOR I IN 1..5 LOOP
      Put (Cats(I));
      New_Line;
   END LOOP;

   -- Determine and display the oldest cat.
   New_Line;
   Put ("The oldest cat is ");
   Put (MaxAge (Cats));
   New_Line;

   -- Determine and display the cat with most lives.
   Put ("The cat with the most lives is ");
   Put (MaxLives (Cats));
   New_Line;

   -- Invite the user to enter a cat and tell the user if an
   -- identical cat is in the array. Two cats are identical if
   -- they have the same id, age, and lives.
   -- Repeat until the user types cntrl-c.
   New_Line;
   Put_Line ("Enter cats and I will tell you if they are in the array");
   Put_Line ("Type cntrl-c to quit");
   LOOP
      Get(Cat);
      IF InArray (Cats, Cat) THEN
         Put_Line ("This cat is in the array");
      ELSE
         Put_Line ("This cat is not in the array");
      END IF;
      New_Line;
   END LOOP;

END;